<?php
 // Include all RAP classes
define("RDFAPI_INCLUDE_DIR", "./rdfapi-php/api/");
include(RDFAPI_INCLUDE_DIR . "RdfAPI.php");
$place=$_GET['place'];

// Create a SPARQL client
$client = ModelFactory::getSparqlClient("http://dbpedia.org/sparql");
$client->setOutputFormat("XML");
 $querystring = '
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX foaf: <http://xmlns.com/foaf/0.1/>
PREFIX dbpedia2: <http://dbpedia.org/property/>
PREFIX dbpedia: <http://dbpedia.org/>
PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
SELECT DISTINCT ?person ?label ?givenname ?surname ?birth ?death ?image ?resume ?labelconcept
 WHERE {
{?person <http://dbpedia.org/property/cityofbirth> <'.$place.'>.}
	UNION {
	?person <http://dbpedia.org/property/birthPlace> <'.$place.'>.
	}
	UNION {
	?person <http://dbpedia.org/property/birthplace> <'.$place.'>.
	}
	UNION {
	?person <http://dbpedia.org/property/placeofbirth> <'.$place.'>.
	}
	UNION {
	?person <http://dbpedia.org/property/placeOfBirth> <'.$place.'>.
	}
	UNION {
	?person <http://dbpedia.org/property/placebirth> <'.$place.'>.
	}
	UNION {
	?person <http://dbpedia.org/property/placeBirth> <'.$place.'>.
	}
?person rdfs:label ?label .
OPTIONAL {?person rdfs:comment ?resume.}.
OPTIONAL {?person foaf:img ?image .}.
OPTIONAL { ?person foaf:givenname ?givenname .}.
OPTIONAL { ?person foaf:surname ?surname .}.
OPTIONAL {?person dbpedia2:birth ?birth .}.
OPTIONAL {?person dbpedia2:death ?death .}.
?person rdf:type ?concept.
?concept rdfs:label ?labelconcept.
FILTER (lang(?label)="fr")
FILTER (lang(?resume)="fr")
}
';
$query = new ClientQuery();
$query->addDefaultGraph("http://dbpedia.org");
$query->query($querystring);
$result = $client->query($query);
$xml = new SimpleXMLElement($result);
$xml->registerXPathNamespace('sparql', 'http://www.w3.org/2005/sparql-results#');
echo '{ "items" : [';
 foreach ($xml->xpath('//sparql:result') as $line)
 {
  $line->registerXPathNamespace('sparql', 'http://www.w3.org/2005/sparql-results#');
  $person=$line->xpath('sparql:binding[@name="person"][1]/sparql:uri');

  $label=$line->xpath('sparql:binding[@name="label"][1]/sparql:literal');
  $label=$label[0];
  $label=str_replace('"','', $label);
  

  $givenname=$line->xpath('sparql:binding[@name="givenname"][1]/sparql:literal');
  $givenname=$givenname[0];
  $givenname=str_replace('"','', $givenname);
  

  $resume=$line->xpath('sparql:binding[@name="resume"][1]/sparql:literal');
  $resume=$resume[0];
  $resume=str_replace('"','', $resume);
  
  $resume=addslashes($resume);
  
  $resume=str_replace('�','à', $resume);

  $surname=$line->xpath('sparql:binding[@name="surname"][1]/sparql:literal');
  $surname=$surname[0];
  $surname=str_replace('"','', $surname);
  

  $image=$line->xpath('sparql:binding[@name="image"][1]/sparql:uri');
  $image=$image[0];
  $essai=strpos($image, ".svg");
  if ($essai === false) {
   $image=$image;
  }
  else {
   $image=""; 	
  }

  $birth=$line->xpath('sparql:binding[@name="birth"][1]/sparql:literal');
  $birth=$birth[0];
  $birth=str_replace('"','', $birth);
  

  $labelconcept=$line->xpath('sparql:binding[@name="labelconcept"][1]/sparql:literal');
  $labelconcept=$labelconcept[0];
  $labelconcept=str_replace('"','', $labelconcept);
  

  $death=$line->xpath('sparql:binding[@name="death"][1]/sparql:literal');
  $death=$death[0];
  $death=str_replace('"','', $death);
    



  echo '{
     person : "'.$person[0].'",
     
     label : "'.$label.'",';
     if ($givenname!=""){echo 'givenname : "'.$givenname.'",';}
     if ($surname!=""){echo 'surname : "'.$surname.'",';}
     if ($resume!=""){echo 'resume : "'.$resume.'",';}
     if ($image!=""){echo '"imageurl" : "'.$image.'",';}
     if ($birth!=""){echo '"birth": "'.$birth.'",';}
     if ($death!=""){echo '"death": "'.$death.'",';}
     echo 'labelconcept: "'.$labelconcept.'",
     },';

}
echo ']
}';
?>
